##:GDC@GDC
class GDC
/*-p-
@b:Klasa zawierajca podstawowe metody tworzenia grafiki
Klasa GDC jest klas bazow dla wszystkich klas graficznych 
/*/

##:Graphics@Graphics
class Graphics
/*-p-
@b:Klasa Graphics dziedziczy metody po klasie GDC
Jest przeznaczona do obsugi grafiki kontrolki %PaintBox 
/*/

#-client@GDC
Range client 	
#?-GDC 	
GDC()
 	
#?-~GDC 	
~GDC() 
	
#-SetPen@GDC
void SetPen(const Pen& pen) 
/*-p-
@b:Ustaw nowe piro
Ustawienie nowego pira (%Pen) umoliwia zmian koloru, gruboci i stylu rysowanej lini.
/*/	

#-SetBrush@GDC
void SetBrush(const Brush& brush) 
/*-p-
@b:Ustaw nowy pdzel
Ustawienie nowego pdzla umoliwia zmian koloru i stylu wypenianego obszaru.
/*/
		
#-SetFont@GDC
void SetFont(const Font& font) 
/*-p-
@b:Ustaw now czcionk
Ustawienie nowej czcionki umoliwia zmian koloru, wielkoci i stylu rysowanego tekstu.
/*/	

#-MoveTo@GDC
void MoveTo(int x, int y) 	
/*-p-
@b:Ustaw now pozycj kursora graficznego.
Ustawienie nowej pozycji kursora nie powoduje powstania jakiegokolwiek ladu na ekranie.
/*/	

#-LineTo@GDC
void LineTo(int x, int y) 	
/*-p-
@b:Rysuj lini od biecej pozycji kursora do punktu [x,y]
Pozycja [x,y] staje si automatycznie now pozycj kursora.
/*/	

#-Rectangle@GDC
void Rectangle(int x1, int y1, int x2, int y2) 	
/*-p-
@b:Rysuje prostokt. 
Rysowany prostokt wyznaczaj przeciwlwge wierzchoki. 
Wsprzdne [x1,y1] oznaczaj prawy-gry wierzchoek a [x2,y2] lewy-dolny.  
Pozycja kursora nie ulega zmianie
/*/	

#-Polyline@GDC
void Polyline(const Point p[], int count) 	
/*-p-
@b:Rysuje aman czc punkty podane w tablicy p[]
Parametr count musi podawa liczb punktw podanych w tablicy.
Pozycja kursora nie ulega zmianie
/*/	

#-Polygon@GDC
void Polygon(const Point p[], int count) 	
/*-p-
@b:Rysuje i wypenia obszar wielokta.  
Punkty podane w tablicy p[] definij wierzchoki wypenianego wielokta.
Do wypeniania uywany jest aktualny pdzel (%Brash)
/*/	

#-FillRect@GDC
void FillRect(int x1, int y1, int x2, int y2) 
/*-p-
@b:Rysuje i wypenia obszar prostokta.  
Wsprzdne [x1,y1] oznaczaj prawy-gry wierzchoek a [x2,y2] lewy-dolny wypenianego prostokta.  
Do wypeniania uywany jest aktualny pdzel (%Brash)
/*/	

#-RoundRect@GDC
void RoundRect(int x1, int y1, int x2, int y2, int wd, int ht) 	
/*-p-
@b:Rysuje i wypenia prostokt o zaokrglonych wierzchokach. 
Wsprzdne [x1,y1] oznaczaj prawy-gry wierzchoek a [x2,y2] lewy-dolny wypenianego prostokta.  
Wielko zaokrglenia okrelaj wd i ht.
Prostokt ten jest wypeniany, aktualnym pdzelem (%Brash)
/*/	

#-Ellipse@GDC
void Ellipse(int x1, int y1, int x2, int y2) 	
/*-p-
@b:Rysuje i wypenia elips.
Wsprzdne [x1,y1] oznaczaj prawy-gry wierzchoek a [x2,y2] lewy-dolny prostokta ograniczajcego
(opisanego na elipsie) obszar elipsy.   
Elipsa wypeniana jest aktualnym pdzelem (%Brash)
/*/	

#-Circle@GDC
void Circle(int x, int y, int r) 	
/*-p-
@b:Rysuje i wypenia okrg.
Wsprzdne [x,y] okrelaj rodek okrgu a r promie. 
/*/	

#-Arrow@GDC
void Arrow(int x1, int y1, int x2, int y2) 	
/*-p-
@b:Rysuje lini zakoczon grotem
Linia rysowana jest od punktu [x1,y1] do punktu [x2,y2] i koczy si grotem.
/*/	

#-SetPixel@GDC
void SetPixel(int x, int y, Color col) 	
/*-p-
@b:Ustaw kolor piksela w punkcie x,y
Parametr col okrela kolor tego pixela.
/*/	

#-GetPixel@GDC
Color GetPixel(int x, int y) 	
/*-p-
@b:Funkcja ktra zwraca kolor piksela w [x,y]
/*/	

#-TextOut@GDC
void TextOut(int x, int y, const string &s) 	
/*-p-
@b:Wypisuje tekst w punkcie [x,y]  
Czcionk tekstu mona zmieni poleceniem %SetFont
/*/	

#?-ExtTextOut@GDC
bool ExtTextOut(int x, int y, UINT nOptions, Range &rect, LPCTSTR lpszString, UINT nCount=-1, int *lpDxWidths=NULL) 
/*-p-
@b:
/*/	

#?-SetBkColor@GDC
int SetBkColor(const Color crColor) 
/*-p-
@b:
/*/	

#?-SetTextColor@GDC
int SetTextColor(const Color crColor) 
/*-p-
@b:
/*/	

#-FillSolidRect@GDC
void FillSolidRect(int x, int y, int cx, int cy, const Color clr) 	
/*-p-
@b:Rysuje i wypenia obszar prostokta zadanym kolorem.  
Dwie przecione metody do szybkiego wypeniania obszaru.
Do wypeniania nie jest uywantaktualny pdzel!!!
/*/

#-FillSolidRect@GDC
void FillSolidRect(Range &rect, const Color clr) 	
/*-p-
@b:Rysuje i wypenia obszar prostokta zadanym kolorem.  
Metoda przeciona uywajca parametru Range
/*/	
	
#-Draw@GDC
void Draw(int left, int top, int width, int height, Bitmap &src) 	
/*-p-
@b:Kopiuje obraz mapy bitowej
/*/	

#-Clear@GDC
void Clear(Color color=Color::cWhite) 	
/*-p-
@b:Wypenia cay dostpny obszar zadanym kolorem 
Domylnie kolor ta jest biay.
/*/	

