#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

//#define GLUT_DISABLE_ATEXIT_HACK
#include <GL/freeglut.h>
//#include <glut.h>

const int cBallNum = 100;

struct GlColor {float R,G,B;};

struct Ball
{
	GlColor color;
	float x,y,z;
} balls[cBallNum];


float  angle=0.0f,  distance=150.0f;

float  light_pos[4]={-1.0,1,0.0,0.0};
float light_spec[4]={1.0,1.0,0.0,0.0};



void InitBalls()
{
	for (int i=0; i<cBallNum; ++i) {
		// set color
		balls[i].color.R = rand()%100/100.0;
		balls[i].color.G = rand()%100/100.0;
		balls[i].color.B = rand()%100/100.0;
		balls[i].x = -50+rand()%100;
		balls[i].y = -50+rand()%100;
		balls[i].z = -50+rand()%100;
	}

}


void OnDisplay()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(70.0, 1.0, 0.1,1000.0);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(0.0,0.0,-distance, 0.0,0.0,1.0, 0.0,1.0,0.0);  // kamera

	//swiatlo : ---
	glPushMatrix();
	glLoadIdentity();
	glLightfv(GL_LIGHT0, GL_POSITION, light_pos);
	glLightfv(GL_LIGHT0,  GL_SPECULAR , light_spec);
	glEnable(GL_LIGHT0);
	glPopMatrix();
	//---

	glPushMatrix();
	//angle += 0.3f; // autorotate
	glRotatef(angle, 0.0, 1.0, 0.0);  // rotate round axis: (0,1,0)

	for (int i=0; i < cBallNum; ++i) {
		glColor3f(balls[i].color.R, balls[i].color.G, balls[i].color.B);
		glPushMatrix();
		balls[i].x += rand()%100/100.0 - 0.5;
		balls[i].y += rand()%100/100.0 - 0.5;
		balls[i].z += rand()%100/100.0 - 0.5;

		glTranslatef(balls[i].x, balls[i].y, balls[i].z);

		glutSolidSphere(3,16,16);

		glPopMatrix();
	}
	glPopMatrix();
	glutSwapBuffers();
}



void OnKeyboard(int ch, int x, int y)
{
   switch (ch) {
      case GLUT_KEY_F10 :
			exit(0); break;
      case GLUT_KEY_LEFT:
			angle -= 0.6f; break;
      case GLUT_KEY_RIGHT:
			angle += 0.6f; break;
      case GLUT_KEY_DOWN:
			distance += 5.0f; break;
      case GLUT_KEY_UP:
			distance -= 5.0f; break;
   }
}


void OnIdle() {
  glutPostRedisplay();
}

void OnVisibile(int vis)
{
  if (GLUT_VISIBLE == vis)  glutIdleFunc(OnIdle);
  else glutIdleFunc(0);
}




int main(int argc, char *argv[])
{
	InitBalls();
	//glutInitWindowPosition(10, 10);
	glutInitWindowSize(800, 600);
	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutCreateWindow("PGK5");

    //set colback rutines
	glutDisplayFunc(OnDisplay);
	//glutKeyboardFunc(OnKeyboard);   for normal keys
	glutSpecialFunc(OnKeyboard);  // for special keys
	glutVisibilityFunc(OnVisibile);
    //set params
	glEnable(GL_LIGHTING);
	glEnable(GL_COLOR_MATERIAL);
	glEnable(GL_DEPTH_TEST);
	glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);

	glShadeModel(GL_SMOOTH);
	glLineWidth(1.0);
	glPointSize(1.0);
	glPolygonMode(GL_FRONT, GL_FILL);
	glFrontFace(GL_CW);
	glDisable(GL_CULL_FACE);

	glClearColor(0.0,0.0,0.0,0.0);
	glutMainLoop();
	return 0;
}







