#include "main.h"


int Application::Main(const ArgumentList& args)
{
	MainForm mfrm;
	mfrm.Show();
	return 0;
}



void MainForm::Initialize()
{
	//!init
	this->SetBounds(0, 0, 653, 499);
	this->onCreate.Add_H(this, &This::DoOnCreate);
	//!<DataGrid>
	dataGrid1.dock = Dock::cLeft;
	dataGrid1.width = 400;
	dataGrid1.text = "dataGrid1";
	dataGrid1.colCount = 4;
	dataGrid1.rowCount = 12;
	dataGrid1.editLabels = true;
	this->Add(&dataGrid1);
	//!<Button>
	button1.SetBounds(408, 66, 102, 34);
	button1.text = "Set rows";
	button1.onClick.Add_H(this, &This::Button1DoOnClick);
	this->Add(&button1);
	//!<Button>
	button2.SetBounds(525, 66, 95, 34);
	button2.text = "Fill data";
	button2.onClick.Add_H(this, &This::Button2DoOnClick);
	this->Add(&button2);
	//!<SpinEdit>
	spinEdit1.SetBounds(410, 33, 99, 22);
	spinEdit1.value = 12;
	this->Add(&spinEdit1);
	//!<Label>
	label1.SetBounds(410, 11, 80, 17);
	label1.text = "Row count:";
	this->Add(&label1);
	//!<Button>
	button3.SetBounds(409, 125, 100, 34);
	button3.text = "Add row";
	button3.onClick.Add_H(this, &This::Button3DoOnClick);
	this->Add(&button3);
	//!<Button>
	button4.SetBounds(528, 125, 92, 34);
	button4.text = "Delete row";
	button4.onClick.Add_H(this, &This::Button4DoOnClick);
	this->Add(&button4);
	//!<Edit>
	edit1.SetBounds(419, 219, 85, 24);
	this->Add(&edit1);
	//!<Edit>
	edit2.SetBounds(529, 220, 86, 24);
	this->Add(&edit2);
	//!<Label>
	label2.SetBounds(421, 198, 80, 18);
	label2.text = "Energy";
	this->Add(&label2);
	//!<Label>
	label3.SetBounds(530, 198, 87, 18);
	label3.text = "Temperature";
	this->Add(&label3);
	//!<Button>
	button5.SetBounds(456, 260, 121, 34);
	button5.text = "Read data";
	button5.onClick.Add_H(this, &This::Button5DoOnClick);
	this->Add(&button5);
	//!end
	dataGrid1.columns[0].width = 70;
	dataGrid1.columns[0].text="Time";
	dataGrid1.columns[1].width = 100;
	dataGrid1.columns[1].align = Align::cCenter;
	dataGrid1.columns[1].text="Energy";
	dataGrid1.columns[2].width = 130;
	dataGrid1.columns[2].text="Temperature";
	dataGrid1.columns[2].align = Align::cRight;
	dataGrid1.columns[3].text="Test";
}


void MainForm::DoOnCreate(NotifyArgs &e)
{
	for(int r=0; r<dataGrid1.rowCount; ++r) {
		dataGrid1.items.Set("0", r, 1);
		dataGrid1.items.Set("0", r, 2);
		dataGrid1.items.Set("xx "+ToStr(r), r, 3);
	}
}



// Set row count
void MainForm::Button1DoOnClick(NotifyArgs &e)
{
	dataGrid1.rowCount = spinEdit1.value.get();
}


//Fill data
void MainForm::Button2DoOnClick(NotifyArgs &e)
{
	for(int r=0; r<dataGrid1.rowCount; ++r) {
		dataGrid1.items.Set(ToStr(r*r), r, 1);
		dataGrid1.items.Set(ToStr(r*r*r), r, 2);
		dataGrid1.items.Set("test "+ToStr(r), r, 3);
	}
}


//Add row
void MainForm::Button3DoOnClick(NotifyArgs &e)
{
	static int n =0;
	dataGrid1.items.Add("new "+ToStr(++n));
}


//Remove focused row
void MainForm::Button4DoOnClick(NotifyArgs &e)
{
	if(dataGrid1.focusedItem<0) {
		MsgBox("Select a row to delete");
		return; //no focused row
	}
	dataGrid1.items.Remove(	dataGrid1.focusedItem);
}


// Read data
void MainForm::Button5DoOnClick(NotifyArgs &e)
{
	if(dataGrid1.focusedItem<0) {
		MsgBox("Select a row");
		return; //no focused row
	}
	edit1.text = dataGrid1.items.Get(dataGrid1.focusedItem, 1);
	edit2.text = dataGrid1.items.Get(dataGrid1.focusedItem, 2);
}






