#include "main.h"

using namespace rofrm;

MainForm *mainForm;


MainForm::MainForm()
{
	//!init
	this->SetBounds(0, 0, 524, 440);
	//!<Button>
	button1.SetBounds(384, 304, 95, 32);
	button1.text = "ShowDialog";
	button1.onClick.Add_H(this, &This::Button1DoOnClick);
	this->Add(&button1);
	//!<Button>
	button2.SetBounds(384, 246, 95, 32);
	button2.text = "Show";
	button2.onClick.Add_H(this, &This::Button2DoOnClick);
	this->Add(&button2);
	//!<Button>
	openBtn.SetBounds(47, 71, 99, 32);
	openBtn.text = "Open file";
	openBtn.onClick.Add_H(this, &This::OpenBtnDoOnClick);
	this->Add(&openBtn);
	//!<Button>
	saveBtn.SetBounds(171, 71, 99, 32);
	saveBtn.text = "Save file";
	saveBtn.onClick.Add_H(this, &This::SaveBtnDoOnClick);
	this->Add(&saveBtn);
	//!<Label>
	label1.SetBounds(53, 20, 371, 16);
	label1.text = "label1";
	this->Add(&label1);
	//!<Label>
	label2.SetBounds(52, 46, 369, 16);
	label2.text = "label2";
	this->Add(&label2);
	//!<Button>
	dirBtn.SetBounds(47, 153, 99, 32);
	dirBtn.text = "Directory";
	dirBtn.onClick.Add_H(this, &This::DirBtnDoOnClick);
	this->Add(&dirBtn);
	//!<Label>
	label3.SetBounds(52, 133, 349, 16);
	label3.text = "label3";
	this->Add(&label3);
	//!<Button>
	msgBtn.SetBounds(47, 246, 99, 32);
	msgBtn.text = "MessageBox";
	msgBtn.onClick.Add_H(this, &This::MsgBtnDoOnClick);
	this->Add(&msgBtn);
	//!<Button>
	button3.SetBounds(47, 296, 99, 32);
	button3.text = "ConfirmBox";
	button3.onClick.Add_H(this, &This::Button3DoOnClick);
	this->Add(&button3);
	//!end
}


class PopupForm: public Form
{
	typedef PopupForm This;
public:
	//!decl
	Edit memo1;
	Button button1, button2;
	//!end
	PopupForm()   {
		windowType=Form::cToolWindow;
		initialize();
	}
private:
	void initialize(){
		//!init
		this->SetBounds(0, 0, 624, 440);
		//!<Memo>
		memo1.SetBounds(40, 22, 373, 23);
		memo1.text = "memo1";
		this->Add(&memo1);
		//!<Button>
		button1.SetBounds(456, 309, 80, 32);
		button1.kind = Button::cOk;
		this->Add(&button1);
		//!<Button>
		button2.SetBounds(156, 307, 80, 32);
		button2.kind = Button::cCancel;
		this->Add(&button2);
		//!end
	}
};



//static HelpSys2  hDlg; //ok
void MainForm::Button1DoOnClick(NotifyArgs &e)
{
	PopupForm  popup; //ok
	popup.ShowDialog();
	MsgBox("After ShowDialog()");
}

void MainForm::Button2DoOnClick(NotifyArgs &e)
{
	static PopupForm  popup; //ok
	popup.Show();
	MsgBox("After Show()");
}







int Application::Main(const ArgumentList& args)
{
	MainForm mainF;
	mainForm = &mainF;
	mainF.Show();
	return 0;
}

void MainForm::DirBtnDoOnClick(NotifyArgs &e)
{
	DirectoryDialog dlg("Title", "/temp");
	if(dlg.Execute())
		label3.text=dlg.directory;
}




void MainForm::OpenBtnDoOnClick(NotifyArgs &e)
{
	FileDialog dlg("Open title", FileDialog::cOpen);
	if(dlg.Execute()) {
		label1.text = dlg.fileName;
		label2.text = dlg.directory;
	}
}



void MainForm::SaveBtnDoOnClick(NotifyArgs &e)
{
	FileDialog dlg("Save title", FileDialog::cSave);
	if(dlg.Execute()) {
		label1.text = dlg.fileName;
		label2.text = dlg.directory;
	}
}



void MainForm::MsgBtnDoOnClick(NotifyArgs &e)
{
	Application::MsgBox("This is info", "Box title", 0);

}

void MainForm::Button3DoOnClick(NotifyArgs &e)
{
	if(ConfBox("Do you want to see an info?"))
		MsgBox("This is info");
	// or
	bool cancel;
	if(ConfBox("Do you want to see an info?", &cancel))
		MsgBox("This is info");
	if(cancel)
		MsgBox("You have pressed cancel");
}

