#include "main.h"


int Application::Main(const ArgumentList& args)
{
	MainForm mfrm;
	mfrm.Show();
	return 0;
}


void MainForm::Initialize()
{
	//!init
	this->SetBounds(0, 0, 892, 596);
	this->text = "Draw test";
	//!<PaintBox>
	paintBox.dock = Dock::cFill;
	this->Add(&paintBox);
	//!<Panel>
	panel.dock = Dock::cRight;
	panel.width = 151;
	this->Add(&panel);
	//!<Button>
	drawBtn.SetBounds(33, 185, 80, 28);
	drawBtn.text = "Refresh";
	drawBtn.onClick.Add_H(this, &This::DrawBtnDoOnClick);
	panel.Add(&drawBtn);
	//!<Button>
	closeBtn.SetBounds(32, 481, 80, 28);
	closeBtn.text = "Close";
	closeBtn.onClick.Add_H(this, &This::CloseBtnDoOnClick);
	panel.Add(&closeBtn);
	//!end
	paintBox.onDraw.Add_H(this, &This::DoOnDraw);
}


int x=200, y=200;

void MainForm::DoOnDraw(NotifyArgs &e)
{
	Graphics g(paintBox);
	//g.Clear();
	g.TextOut(270,20, "Drawing demo");
	Pen red(Color::cRed);
	Pen blue(Color::cBlue, 3);
	g.MoveTo(0,100);
	for(int i=0; i<80; ++i){
		int y=100+200*(i%2);
		g.SetPen(red);
		g.LineTo(10*i,y);
		g.SetPen(blue);
		g.LineTo(10+10*i,y);
	}
	Brush brush(Color::cGreen);
	g.SetBrush(brush);
	g.FillRect(100,350, 50, 40);
	Range rect(200,350,300,400);
	g.FillSolidRect(rect, Color::cMagenta);
	g.Circle(200,200, 40);
	g.SetPixel(10,10, Color::cRed);
	g.MoveTo(x,y);
	x+=Random(40)-20;
	y+=Random(40)-20;
	g.LineTo(x,y);
}


void MainForm::DrawBtnDoOnClick(NotifyArgs &e)
{
  paintBox.Redraw();
}



void MainForm::CloseBtnDoOnClick(NotifyArgs &e)
{
  Close();
}


