#include "main.h"

using namespace stdrand;

int Application::Main(const ArgumentList& args)
{
	MainForm mfrm;
	mfrm.Show();
	return 0;
}



void MainForm::Initialize()
{
	//!init
	this->SetBounds(0, 0, 952, 717);
	//!<PlotXY>
	plotXY1.SetBounds(5, 2, 453, 293);
	this->Add(&plotXY1);
	//!<PlotXY>
	plotXY2.SetBounds(465, 1, 467, 295);
	this->Add(&plotXY2);
	//!<Button>
	button1.SetBounds(359, 297, 84, 34);
	button1.text = "Wykres 1";
	button1.onClick.Add_H(this, &This::Button1DoOnClick);
	this->Add(&button1);
	//!<Button>
	button2.SetBounds(838, 301, 84, 34);
	button2.text = "Wykres 2";
	button2.onClick.Add_H(this, &This::Button2DoOnClick);
	this->Add(&button2);
	//!<PlotXY>
	plotXY3.SetBounds(5, 339, 451, 291);
	this->Add(&plotXY3);
	//!<Button>
	button3.SetBounds(358, 636, 84, 34);
	button3.text = "Wykres 3";
	button3.onClick.Add_H(this, &This::Button3DoOnClick);
	this->Add(&button3);
	//!<Button>
	button4.SetBounds(520, 366, 141, 39);
	button4.text = "Licz srednia";
	button4.onClick.Add_H(this, &This::Button4DoOnClick);
	this->Add(&button4);
	//!<Button>
	button5.SetBounds(686, 366, 141, 39);
	button5.text = "Zapisz dla Excel'a";
	button5.onClick.Add_H(this, &This::Button5DoOnClick);
	this->Add(&button5);
	//!<Edit>
	edit1.SetBounds(554, 338, 80, 23);
	this->Add(&edit1);
	//!<CheckBox>
	checkBox1.SetBounds(9, 304, 196, 22);
	checkBox1.text = "Schowaj/Pokaz dane1";
	checkBox1.checked = true;
	checkBox1.onClick.Add_H(this, &This::CheckBox1DoOnClick);
	this->Add(&checkBox1);
	//!end
}



//Standardowe serie XY
Series seria1, seria2, seria3;
// Seria  pole bledu
ErrSeries bladSer;
//Seria dla rezkladow
DistribSeries rozkladSer;


void MainForm::PlotInit()
{
	// Dodajemy seria danych do wykresu 1
	plotXY1.AddSeries(&seria1);
	plotXY1.AddSeries(&seria2);
	// Wykres 2 z polem bledu
	plotXY2.AddSeries(&seria3);
	plotXY2.AddSeries(&bladSer);
	// Wykres 3 rozklad
	plotXY3.AddSeries(&rozkladSer);
	// dla tej serii trzeba ustawic zakres x oraz liczbe sektorow w przedziale
	rozkladSer.SetRange(-1,1, 20);  // przedzial od -1 do 1 podzielony na 20 sektorow
}



//Wykres 1
void MainForm::Button1DoOnClick(NotifyArgs &e)
{
	//Usun porzednie dane
	seria1.Clear();
	seria2.Clear();
	double wsp = Random(), par = Random();
	//Wprowadz nowe dane
	for(double x=0; x<10; x+=0.02) {
		double y1 = cos(x)*exp(-wsp*x);
		seria1.AddXY(x, y1);
		double y2 = cos(2.0*x) - sin(par*x);
		seria2.AddXY(x, y2);
	}
	//Przerysuj wykres plotXY1
	plotXY1.Redraw();
}



//Wykres 2
void MainForm::Button2DoOnClick(NotifyArgs &e)
{
	//Usun porzednie dane
	seria3.Clear();
	bladSer.Clear();
	double wsp = 0.6*Random();
	//Wprowadz nowe dane
	for(double x=0; x<10; x+=0.2) {
		double y = cos(x)*exp(-wsp*x);
		seria3.AddXY(x, y);
		double dy = 0.1+0.1*cos(2.0*x);
		bladSer.AddErrBar(x, y, dy);
	}
	//Przerysuj wykres plotXY1
	plotXY2.Redraw();
}


//Wykres 2
void MainForm::Button3DoOnClick(NotifyArgs &e)
{
	//Usun porzednie dane
	rozkladSer.Clear();
	for(int i=0; i<10000;  ++i) {
		double x = 2*Random() - 1;
		rozkladSer.AddX(x);
		//lub
		//rozkladSer.AddX(x, waga);
	}
	//Przerysuj wykres plotXY1
	plotXY3.Redraw();

}


//Dostep do danych w serii - obliczanie sredniej
void MainForm::Button4DoOnClick(NotifyArgs &e)
{
	if(seria3.Count()==0) return;
	double srednia =0;
	for(int i=0; i<seria3.Count(); ++i) {
		srednia += seria3[i].y;
	}
	srednia /= seria3.Count();
	edit1.text = ToStr(srednia);
}



void MainForm::Button5DoOnClick(NotifyArgs &e)
{
	FileDialog dlg("Zapisz dane", FileDialog::cSave);
	dlg.filter = "Excel csv Files (*.csv)|*.csv";
    dlg.defaultExt = "csv";
	if(dlg.Execute())
		seria3.SaveToFile(dlg.GetFullName());
}



void MainForm::CheckBox1DoOnClick(NotifyArgs &e)
{
	seria1.visible = checkBox1.checked;
	plotXY1.Redraw();
}

