#pragma once
#include<rofrm>
#include <SciEditor.h>


enum {cMarkSel=0, cMarkBreak, cMarkError,  cMarkRun};

class UserCfg;

class MyEditor : public SciEditor
{
public:
	bool isBrowsed;
	string filePath;
	MyEditor();
	bool IsModified() {return modified;}
	void SetDebugLine(int line) {HighlightLine(line, cMarkRun);}
	int ToggleBreakpoint(int &line, int oper=0);
	void ClearBreakpoints() {
		HighlightLine(-1, cMarkBreak, false);
	}
	void Open(string fn);
	bool Save();
	string ParseForExpr(string s, int pos);
	void GoToLine(int line)  {GotoLineEnsureVisible(line);}
	void InsertStrList(StringList &lines);
	int GetMarginWidth();
protected:
	bool showMessages;
	void OnCharAdded();
	void OnChangeState();
	bool FillCompleteList(string &pat, string &list);
	bool FillCallTipList(string &pat, string &list);
	void UpdateDisplay(int type);
	void OnWordTooltip(int pos);
private:
	SciLexerDef* GetLexerDef(const string fn);
	bool isexprcharforsel(char ch);

};


