#pragma once
#include<rofrm>
#include "MyEditor.h"


class MainForm: public Form
{
	typedef MainForm This;
public:
	//Actions
	Action *fileNew, *fileOpen, *fileSave;
	ActionList fileActs, helpActs, ctxActs;
	//--------------- Menu -----------------------
	Menu fileMenu, editMenu, helpMenu;
	MenuBar menuBar;
	//!decl
	ToolBar toolBar;
	StatusBar statusBar;
	MyEditor editor;
	//!end
	MainForm() {
		Initialize();
		CreateActionList();
		SetupMenu();
		SetupToolbar();
		SetupStatusbar();
	}
	void OpenFile(string fn);
	void CmdOpenFile();
	void CmdNewFile();
	bool CmdSaveFile(bool  as);
	void CmdAbout();
	void CmdClose();
	void HandleCmd(int cmd);
	void SpecialHandleCmd(int cmd);
	void ViewCurPos(int x, int y);
	void SetMacroBtn(bool on);
private:
	void Initialize() ;
	void CreateActionList();
	void SetupMenu();
	void SetupToolbar();
	void SetupStatusbar();
	void DoOnContextMenu(MouseArgs &e);
	void DoOnCreate(NotifyArgs &e);
	void DoOnClose(NotifyArgs &e);

};

extern
MainForm *mainForm;
