#include "main.h"



MainForm *mainForm=NULL;
bool doRun = false;


int Application::Main(const ArgumentList& args)
{
	MainForm mainF;
	mainForm = &mainF;
	mainF.Show();
}


MainForm::MainForm()
{
	Initialize();
	Randomize();
}


void MainForm::Initialize()
{
	//!init
	this->SetBounds(0, 0, 755, 565);
	this->text = "MainForm";
	//!<PaintBox>
	paintBox.dock = Dock::cFill;
	paintBox.onDraw.Add_H(this, &This::DoOnDraw);
	this->Add(&paintBox);
	//!<Button>
	startBtn.SetBounds(7, 419, 84, 34);
	startBtn.text = "Start";
	startBtn.kind = Button::cRun;
	startBtn.onClick.Add_H(this, &This::OnStartBtnClick);
	panel1.Add(&startBtn);
	//!<Label>
	label2.SetBounds(9, 32, 80, 16);
	label2.text = "Step:";
	panel1.Add(&label2);
	//!<Edit>
	stepVal.SetBounds(9, 50, 80, 20);
	stepVal.backColor = Color::cLightGray;
	stepVal.text = "0";
	panel1.Add(&stepVal);
	//!<Panel>
	diode.SetBounds(25, 401, 36, 14);
	diode.borderStyle = BorderStyle::cRised;
	panel1.Add(&diode);
	//!<Panel>
	panel1.dock = Dock::cRight;
	panel1.width = 100;
	panel1.borderStyle = BorderStyle::cFixed3d;
	this->Add(&panel1);
	//!end
}




// System definition
#define NMAX  201
class Paczka
{
  public:
	int i, n;
	typedef  struct {double re, im; }  Zesp;
	double  V[NMAX], x[NMAX];
	Zesp   gam[NMAX], psi[NMAX], r[NMAX];
	Zesp bet;
	double  dx, L, dt, Imb, Reb[NMAX]; //, Rebp[NMAX];;
	double x0, y0;
	Pen red, blue,black;
	Paczka(double V0, double x0_, double y0_): red(Color::cRed), blue(Color::cBlue), black(Color::cBlack) {
		n=NMAX; L=400.;    dx = L/((double) n-1.0); x0=x0_; y0=y0_;
		dt = 0.05;
		ObliczV(V0);
		Obliczbbp();
		PaczkaPocz();
	}

	void ObliczV(double V0){
		for (i=0; i<n; i++){
			x[i] = i*dx;
			if (x[i]<0.7*L)	  V[i] = 0.0;    else    V[i] = V0;
		}
	}

	void Obliczbbp(){
		Imb = -2.*dx*dx/dt;
		for (i=0; i<n; i++){
			Reb[i] =  -2. - dx*dx*V[i];
		}
	}

	void PaczkaPocz(){
		for (i=0; i<n; i++){
			if ( (x[i]>50.) && (x[i]<150.) )	{
				psi[i].re = 80 * cos( (x[i]/100.0-1.0)*M_PI) * cos( (x[i]/100.0-1.0)*M_PI) * sin((x[i]-50)/25*M_PI);
				psi[i].im = 80 * cos( (x[i]/100.0-1.0)*M_PI) * cos( (x[i]/100.0-1.0)*M_PI) * cos((x[i]-50)/25*M_PI);
			}
			else{
				psi[i].re = 0.; psi[i].im = 0.; }
		}
	}



	void Rysuj(Graphics &g) {
		g.SetPen(black);
		g.MoveTo(x0, y0);
		for (i=0; i<n; i++)
			g.LineTo(x[i]+x0, y0-500*V[i]);
		g.SetPen(red);
		g.MoveTo(x0, y0);
		for (i=0; i<n; i++)
			g.LineTo(x[i]+x0+dx, y0-psi[i].re);
		g.LineTo(x[n-1]+2*dx+x0,y0);
		g.SetPen(blue);
		g.MoveTo(x0, y0);
		for (i=0; i<n; i++)
			g.LineTo(x[i]+x0+dx, y0-psi[i].im);
		g.LineTo(x[n-1]+2*dx+x0,y0);
	}

	void Przesun(){
		r[0].re = -Reb[0]*psi[0].re  -  Imb*psi[0].im - psi[1].re;
		r[0].im=  -Reb[0]*psi[0].im + Imb*psi[0].re - psi[1].im;
		for (i=1; i<n-1; i++){
			r[i].re = -psi[i-1].re - Reb[i]*psi[i].re  -  Imb*psi[i].im - psi[i+1].re;
			r[i].im= -psi[i-1].im - Reb[i]*psi[i].im + Imb*psi[i].re - psi[i+1].im;
		}
		r[n-1].re = -psi[n-2].re - Reb[n-1]*psi[n-1].re  -  Imb*psi[n-1].im ;
		r[n-1].im= -psi[n-2].im - Reb[n-1]*psi[n-1].im + Imb*psi[n-1].re ;

		bet.re = Reb[0]; bet.im = Imb;
		double tmp =  bet.re*bet.re + bet.im*bet.im ;
		Zesp z;
		psi[0].re = ( r[0].re*bet.re + r[0].im*bet.im)/tmp;
		psi[0].im = (-r[0].re*bet.im + r[0].im*bet.re)/tmp;
		for (i=1; i<n; i++){
			gam[i].re =  bet.re/tmp;
			gam[i].im = -bet.im/tmp;
			bet.re = Reb[i] - gam[i].re;
			bet.im = Imb - gam[i].im;
			tmp =  bet.re*bet.re + bet.im*bet.im ;
			z.re = r[i].re - psi[i-1].re;
			z.im = r[i].im - psi[i-1].im;
			psi[i].re = ( z.re*bet.re + z.im*bet.im)/tmp;
			psi[i].im = (-z.re*bet.im + z.im*bet.re)/tmp;
		}
		for (i=n-2; i>=0; i--){
			psi[i].re -= gam[i+1].re*psi[i+1].re - gam[i+1].im*psi[i+1].im;
			psi[i].im -= gam[i+1].re*psi[i+1].im + gam[i+1].im*psi[i+1].re;
		}
	}


};





Paczka paczka1(0.01, 50, 100);
Paczka paczka2(0.05, 50, 250);
Paczka paczka3(0.1, 50, 400);


void MainForm::DoOnDraw(NotifyArgs &e)
{
	Graphics g(paintBox);
	g.Clear();
	// Draw system state
	paczka1.Rysuj(g);
	paczka2.Rysuj(g);
	paczka3.Rysuj(g);
}

int tn;

void MainForm::BeforeStart()
{
	tn =0;
	// Set initial state of your system
}


void RunProc(void *p)
{
	while(doRun){
		//calculation code
		//const double dt = 0.005;
		paczka1.Przesun();
		paczka2.Przesun();
		paczka3.Przesun();
		if(tn%100==0) {
			ThreadJob::StartLock();
			mainForm->paintBox.Redraw();
			mainForm->stepVal.text=ToStr(tn);
			//ThreadJob::Sleep(1);
			ThreadJob::StopLock();
		}
		++tn;
	}
	ThreadJob::StartLock();
	mainForm->diode.backColor = Color::cDefault;
	ThreadJob::StopLock();
}


ThreadJob tjob(RunProc);



void MainForm::OnStartBtnClick(NotifyArgs &e)
{
	if(!doRun) {
		doRun = true;
		diode.backColor = Color::cRed;
		startBtn.text = "Stop";
		BeforeStart();
		tjob.Run(0);
	}
	else
	{
		startBtn.text = "Start";
		doRun = false;
	}
}


