#include "main.h"
//#include "dynam2d.h"


MainForm *mainForm=NULL;
bool doRun = false;


int Application::Main(const ArgumentList& args) 
{
	MainForm mainF;
	mainForm = &mainF;
	mainF.Show();
}


MainForm::MainForm()
{
	Initialize();
	Randomize();
}


void MainForm::Initialize() 
{
	//!init
	this->SetBounds(0, 0, 755, 565);
	this->text = "MainForm";
	//!<PaintBox>
	paintBox.dock = Dock::cFill;
	paintBox.onDraw.Add_H(this, &This::DoOnDraw);
	this->Add(&paintBox);
	//!<Button>
	startBtn.SetBounds(7, 419, 84, 34);
	startBtn.text = "Start";
	startBtn.kind = Button::cRun;
	startBtn.onClick.Add_H(this, &This::OnStartBtnClick);
	panel1.Add(&startBtn);
	//!<Label>
	label2.SetBounds(9, 32, 80, 20);
	label2.text = "Step:";
	panel1.Add(&label2);
	//!<Edit>
	stepVal.SetBounds(9, 50, 80, 20);
	stepVal.backColor = Color::cLightGray;
	stepVal.text = "0";
	panel1.Add(&stepVal);
	//!<Panel>
	diode.SetBounds(25, 401, 36, 14);
	diode.borderStyle = BorderStyle::cRised;
	panel1.Add(&diode);
	//!<Panel>
	panel1.dock = Dock::cRight;
	panel1.width = 100;
	panel1.borderStyle = BorderStyle::cFixed3d;
	this->Add(&panel1);
	//!end
}




// System definition




void MainForm::DoOnDraw(NotifyArgs &e)
{
	Graphics g(paintBox);
	g.Clear();
	// Draw system state

}

int tn;

void MainForm::BeforeStart()
{
	tn =0;
	// Set initial state of your system
}


void RunProc(void *p) 
{
	while(doRun){
		//calculation code

		if(tn%100==0) {
			ThreadJob::StartLock();
			mainForm->paintBox.Redraw();
			mainForm->stepVal.text=ToStr(tn);
			//ThreadJob::Sleep(1);
			ThreadJob::StopLock();
		}
		++tn;
	}
	ThreadJob::StartLock();
	mainForm->diode.backColor = Color::cDefault;
	ThreadJob::StopLock();
}


ThreadJob tjob(RunProc);



void MainForm::OnStartBtnClick(NotifyArgs &e)
{
	if(!doRun) {
		doRun = true;
		diode.backColor = Color::cRed;
		startBtn.text = "Stop";
		BeforeStart();
		tjob.Run(0);
	}
	else
	{
		startBtn.text = "Start";
		doRun = false;
	}
}


