#pragma once
#include <cmath>
#include <cstdlib>
#include <cstdio>
#include <ctime>
#include <vector>
#include <string>
#include <cassert>

using namespace std;



namespace stdrand {

	inline double Random()
	{
	  return double(rand())/(RAND_MAX + 1.0);
	}

	inline long Random(int n)
	{
	  return long(n*Random());
	}


	inline void Randomize(unsigned n=0)
	{
	  if(n==0)
		srand((unsigned)time(NULL));
	  else
		srand(n);
	}
}//stdrandom


namespace nrcprand {
	extern long seedrand;

   double ran1(long *idum);

	inline double Random() {
		return ran1(&seedrand);
	}

	inline int Random(int n)
	{
	  double x=ran1(&seedrand);
	  return int(n*x);
	}

	inline void Randomize(unsigned n=0)
	{
	}
}//stdrandom

class TimeClock
{
	long startCount;
public:
	TimeClock(){
		Reset();
	}
	double Get() {
       return double(clock()-startCount)/CLOCKS_PER_SEC;
	}
	string AsString() {
		char buf[64];
		double tm = Get();
		sprintf(buf, "%6.2lf", tm);
		return buf;
	}
	void Reset() {
		startCount = clock();
	}
};

inline
double sqr(double x) {
	return x*x;
}

extern
  TimeClock sysClock;


