#ifndef GCFRM_BTNGROUP_H
#define GCFRM_BTNGROUP_H

#include <Ctrls.h>

namespace rofrm {

class GroupDataLink: public DataLink
{
	property<int> &refer;
public:
	GroupDataLink(Control *ctrl, property<int> &ref);
	DataLink& operator=(Field &fld) {
		field =&fld;
	}
	void Load();
	void Store();
};

class ButtonGroup : public Container {
public:
	int columns;
	StringListProp items;
	event<NotifyArgs> onChange;
	void Layout();
protected:
	ButtonGroup();
};

class RadioGroup : public ButtonGroup{
public:
	GroupDataLink dataLink;
	property<int> itemIndex;
	RadioGroup();
};

class CheckGroup : public ButtonGroup{
public:
	GroupDataLink dataLink;
	property<int> itemFlags;
	CheckGroup();
	bool GetChecked(int ix) {
		int val = itemFlags;
		return (val & (1<<ix))!=0;
	}
	bool SetChecked(int ix, bool state) {
		int val = itemFlags;
		val &= state?(1<<ix) : ~(1<<ix);
		itemFlags = val;
	}
};


};
#endif
