#pragma once

#include <Ctrls.h>
#include <ComboBox.h>
#include <BtnGroup.h>


namespace rofrm {

struct FindDefRec
{
  string findWhat;
  string replaceWhat;
  bool replacing;
  bool havefound;
  bool matchCase;
  bool wholeWord;
  bool reverseFind;
  bool regExp;
  bool wrapFind;
  bool unSlash;
  bool findInStyle;
  int findStyle;
  bool inSelection;
  bool showWarnings;
};



class FindBaseDlg : public Form
{
protected:
	Control *parent;
public:
	FindBaseDlg(Control *ctrl);
	~FindBaseDlg();
	void PopData();
	void PushData();
	//!decl
	Label findLab;
	ComboBox  findCb;
	CheckBox caseChk, wordChk;
	Button findBtn, closeBtn;
	//!end
};


class FindTextDlg : public FindBaseDlg
{
public:
	RadioGroup upDnSel;
	FindTextDlg(Control *ctrl);
	void PopData();
	void PushData();
	void DoOnFind(NotifyArgs &e);
};


class EditReplaceDlg : public FindBaseDlg
{
private:
	bool found;
	Point foundAt;
public:
	//!decl
	Label replaceLab;
	ComboBox  replaceCb;
	RadioGroup rangeSel;
	Button replaceBtn, replaceAllBtn;
	//!end
	EditReplaceDlg(Control *ctrl);
	~EditReplaceDlg();
	void PopData();
	void PushData();
	bool enableScopeSelection;
	Point blockBegin, blockEnd;
	string  newText;
	bool    inBlock;
	event<NotifyArgs> onCmd;
protected:
	bool HandleReplaceCmd(int cmd);
	void DoOnFind(NotifyArgs &e);
	void DoOnReplace(NotifyArgs &e);
	void DoOnReplaceAll(NotifyArgs &e);
};


class GoToLineDlg : public Form
{
public:
	GoToLineDlg();
	Label findLab;
	Edit  lineEd;
	Button gotoBtn, closeBtn;
protected:
	void DoOnGoTo(NotifyArgs &e);
};


class RecentFindList :public vector<string>
{
public:
  void GetItems(ComboBox  &cb);
  void SetItems(ComboBox  &cb);
};


extern
  FindDefRec findRec;

extern
	RecentFindList  findList, replaceList;


}

