#pragma once

#include <Core.h>

namespace rofrm {

class Label : public Control {
public:
	Label();
	property<Align::T> align;
	DataLink dataLink;
};


class CheckDataLink: public DataLink
{
public:
	CheckDataLink(Control *ctrl):DataLink(ctrl) {
	}
	DataLink& operator=(Field &fld) {
		field =&fld;
	}
	void Load();
	void Store();
};





class Button : public Control {
	class Impl;
public:
	enum Kind {cNone, cOk, cCancel, cNo, cOpen, cSave, cPrint, cRun, cGo, cEdit, cSetup, cClose};
	int cmd;
	property<bool> hot;
	property<Kind> kind;
	property<int> icon;
	Button();
	void Click();
	event<NotifyArgs> onClick;
};


class CheckBox : public Control {
	class Impl;
public:
	bool threeState;
	property<bool, true> checked;
	CheckDataLink dataLink;
	CheckBox();
	event<NotifyArgs> onClick;
};


class GroupBox : public Container {
public:
	GroupBox();
};


class Edit : public Control {
public:
	enum DataType {cNormal, cInteger, cFloat, cUpperCase, cPassword};
	class Impl;
	DataLink dataLink;
	property<DataType> dataType;
	property<bool> readOnly;
	property<bool, true> modified;
	event<NotifyArgs> onChange;
	event<ItemArgs> onValidate;
	Edit();
	void SetSel(int start, int end=-1);
};


class Memo : public Control {
	class Impl;
public:
	property<bool> readOnly;
	property<bool, true> modified;
	Memo();
	void SetSel(int start, int end=-1);
	void ReplaceSel(const string& txt, bool bCanUndo=false);
	void AppendText(const string& txt){
		SetSel(-1,-1);
		ReplaceSel(txt);
	}
	void Clear();
};



class Panel : public Container {
public:
	Panel();
protected:
	Panel(Impl *impl):Container(impl){}
};


}

