#pragma once

#include <vector>
#include "CustomCtrl.h"


namespace rofrm{

using namespace std;


class DialCtrl :public CustomCtrl
{
public:
	enum ScaleLabel{cNone, cMinMax, cView};
	DialCtrl();
	property<double> pos;
	property<double> min;
	property<double> max;
	property<int> steps;
	property<bool> showPos;
	property<ScaleLabel> labels;
	event<NotifyArgs> onChange;
protected:
	Point center;
	int radius;
	Color c3DShadow, c3DDKShadow;
	Color c3DLight, c3DHighlight;
	double vmin, vmax, vpos;
	int vsteps;
	bool vshowPos;
	ScaleLabel vlabels;
	Brush dialBrush;
	void Create();
	void UpdateParams();
	void UpdatePosition();
	bool SetPos(double newpos);
	void DrawKnob(GDC &g);
	void DrawScale(GDC &g);
	void DrawDial(GDC &g);
	void DoOnDraw(NotifyArgs &e);
	void DoOnPaint(PaintArgs &e);
	void DoOnMouseDown(MouseArgs &e);
	void DoOnMouseMove(MouseArgs &e);
	void DoOnKeyDown(KeyArgs &e);
	void DoOnLostFocus(NotifyArgs &e);
};

}//namespace
