#pragma once

#include <Core.h>

namespace rofrm {


class ItemListProp
{
public:
	struct ItemType {
		string text;
		int img;
		int data;
	};
	enum {cAdd, cRemove, cClear};
	typedef  std::vector<ItemType> T;
	size_t count() const {return list.size();}
	void Add(const string text, int img, int data=0){
		ItemType itm = {text,img,data};
		list.push_back(itm);
		Notify(cAdd, list.size()-1);
	}
	void Remove(int index) {
		Notify(cRemove, index);
		list.erase(list.begin()+index);
	}
	void Clear() {
		Notify(cClear, list.size());
		list.clear();
	}
	 const ItemType& operator[](int n)  const {return list[n];}
	event<ListArgs> onOperate;
	protected:
	void Notify(int op, int ix){
		ListArgs e(op,ix);
		onOperate.exec(e);
	}
	T list;
};



class IconView : public Control  {
	class Impl;
public:
	ItemListProp items;
	IconView();
	void SetImages(int resId){
		imgResId=resId;
	}
	property<int> selectedIndex;
	event<NotifyArgs> onSelChanged;
	event<NotifyArgs> onChoose;
private:
	int imgResId;
};



}


