#include <Core.h>
#include<Graphics.h>

namespace rofrm {

class  LayoutForm;

class Selector : public object {
	friend class  LayoutForm;
public:
	bool active;
	int deltaX, deltaY;
	Rect bounds;
	Selector(LayoutForm *layout);
	~Selector();
	void MoveRel(int dx, int dy){
		bounds.x+=dx;
		bounds.y+=dy;
		ApplyBounds();
	}
	void ResizeRel(int dx, int dy){
		bounds.width+=dx;
		bounds.height+=dy;
		ApplyBounds();
	}
	void Reset();
	void LinkControl(Control *ctrl);
	Control* GetControl() { return ctrl;}
	//const Rect& GetCtrlBounds() {
	//		return ctrl->GetBounds();
	//}
	//void SetCtrlBounds(Rect &rec);
	void ApplyBounds();
protected:
	class Impl;
	Impl &impl;
	Control *ctrl;
	LayoutForm *layout;
};


typedef void (*TPaintFun)(PaintDC &g);

class ChildCtrl: public Control {
	TPaintFun paint;
public:
	ChildCtrl(TPaintFun pfun=0);
	void Paint(PaintDC &g) {
		paint(g);
	}
};


class  LayoutForm: public Container {
	friend class GlassLayer;
public:
	class Impl;
	Selector selector;
	LayoutForm();
	event<NotifyArgs> onCreate;
	void GetCtrlBounds(Control *ctrl, Rect &rect);
	void Repaint();
};


} //namespace
