#pragma once

#include <Core.h>
#include <vector>

namespace rofrm {


struct Column {
	string text; int width; Align::T align;
};


class ColumnList
{
protected:
	std::vector<Column> value;
public:
	size_t GetCount()  {return value.size();}
	void Add(string txt, int wd, Align::T al=Align::cLeft);
	Column& operator[](int col) {return value[col];}
};

class ListView;

class ListItems
{
protected:
	ListView &list;
public:
	ListItems(ListView &l);
	int GetCount();
	int Add(string s, int nimg=-1);
	void Set(string s, int row=-1, int col=0);
	void SetIcon(int row, int nimg);
	string Get(int row, int col=0) const;
	void Remove(int row);
	bool SetData(int row, uint data);
	uint GetData(int row) const;
	void Clear();
};



class ListView : public Control{
public:
	class Impl;
	enum ViewStyle{stLargeIcon, stSmallIcon, stList, stDetail};
	typedef std::vector<int> SelectedList;
	ListView();
	void SetImages(int resId){
		imgResId=resId;
	}
	bool fullRowSelect;
	bool gridLines;
	bool editLabels;
	bool multiSelect;
	bool showSelection;
	bool headerVisible;
	property<int> colCount;
	property<int> rowCount;

	ViewStyle view;
	ColumnList columns;
	ListItems  items;  // runtime
	property<int, true> focusedItem;
	event<ItemArgs> onPostEdit;
	event<NotifyArgs> onChangeText, onChangeSel;
	event<ItemArgs>	onSearch;
	event<NotifyArgs>  onChoose;
protected:
	int imgResId;
	ListView(Impl *imp);
};

}

