#pragma once
#include <core.h>

using namespace std;

namespace rofrm {

enum SetupMask{ cD8=0x8,  cD7=0x7, cD6=0x6, cS1=0x10, cS2=0x20, //data and stop bits
							  cNoParity=0x0, cOddParity=0x100, EvenParity=0x200,
							  cRtsDisable=0x0, cRtsEnable=0x1000, cRtsHandshake=0x2000,
							  cDtrDisable=0x0, cDtrEnable=0x10000,  cDtrHandshake=0x10000,
							  cB600=0x100000,  cB1200=0x200000,  cB2400=0x400000,
							  cB4800=0x800000,	cB9600=0x1000000,	cB19200=0x2000000};

//example Metex
const int cM_4660A = cB9600|cD7|cS2|cNoParity|cRtsDisable|cDtrEnable;


class PortCOM
{
public:
	int baudRate;
	int dataBits;
	int stopBits;
	int parityType;
	int rtsControl;
	int dtrControl;
	int eventMask;
	PortCOM(int inpLen=128, int outLen=128);
	~PortCOM();
	void Setup(int flags);
	bool Open(const string portName);
	void Close();
	bool WriteData(string data, bool wait=true);
	bool ReadData(string &data, int minLen=1);
protected:
	const int inpBuffLen, outBuffLen;
	Handle comH;
	char *inpBuffer, *outBuffer;
	const char* ReadBuff(int &count);
};


}
