#pragma once
#include<Core.h>

namespace rofrm {

struct SectionParams
{
	bool apply;
	Color foreColor;
	Color backColor;
	Font font;
	string text;
	SectionParams(): font(9)
	{}
};


struct PageSettings
{
	//PrinterSettings *printerSettings;
	bool landscape;  // not used yet
	Range margins;  //pagesetupMargin -user
	//bool color;
	Point paperSize;			//ptPage
	Point printerResolution;  //ptDpi
};

struct PrintPageArgs
{
	HDc hdc;
	int pageNum;
	bool hasMorePages;
	bool printPage;
	PageSettings &pageSettings;
	Range marginBounds;  //rc
	Range pageBounds;  //rcPage
	PrintPageArgs(PageSettings &pgSet):pageSettings(pgSet)
	{}
};


class Printer : public object
{
public:
	SectionParams header;
	SectionParams footer;
	bool selection;
	//bool needPrint;
	int startPos, endPos; // if selection
	string documentName;
	bool Print(bool show=true);
	Printer();
protected:
	PageSettings pageSettings;
	PrintPageArgs pageArgs;
	Range rectMargins, rectPhysMargins;
	//Point ptPage;
	//PageDefs pageDefs;
	virtual void BeforePrint() {}
	virtual void AfterPrint() {}
	//virtual void StartPage();
	virtual void PrintClientArea(PrintPageArgs &pg) {}
};


}//namespace
