#pragma once
#include <Scroller.h>
#include <Ctrls.h>
#include <ComboBox.h>

namespace rofrm {


class PopertyItem: public Panel
{
	friend class PropertyBox;
public:
	enum T {cEdit, cButton, cCombo, cCheck};
	int id;
	T type;
	Label label;
	Edit edit;
	Button button;
	ComboBox combo;
	CheckBox checkBox;
	PopertyItem();
	void SetType(T pbt);
	void Layout();
	void LoadCombo(string ls);
protected:
	Control* refTab[4];
	void Free();
	void DoOnAccept(NotifyArgs &e);
	void DoOnKeyUp(KeyArgs &e);
	void DoOnComboChange(ItemArgs &e) {
		DoOnAccept(e);
	}
};


class PropertyBox: public Scroller
//class PropertyBox: public Panel
{
public:
	PropertyBox();
	~PropertyBox();
	void Layout();
	int GetCount() {
		return itemsCount;
	}
	void SetCount(int count);
	PopertyItem* GetItem(int n) {
		return items[n];
	}
	event<ItemArgs> onApply;
protected:
	int itemsCount;
	vector<PopertyItem*> items;
};



}; //namespace
