#pragma once
#include <Core.h>

namespace rofrm {

class RichView;

class FormatTag
{
	friend class RichView;
	class Impl;
private:
	RichView *view;
	Impl *impl;
	string name;
	void Create();
public:
	Font font;
	Color foreColor;
	Color backColor;
	FormatTag(const string name):impl(0), view(0), name(name)
	{}
	~FormatTag();
};


class RichView : public Control {
public:
	class Impl;
	RichView();
	void RegisterTag(FormatTag &tag){
		tag.view = this;
		tags.push_back(&tag);
	}
	void AppendText(const string s, FormatTag &tag);
	void PutEol();
	void LoadText(const string s);
	void SetScrollPos(long x, long y);
	void Clear();
protected:
	vector<FormatTag*> tags;
};

}
