#pragma once

#include <Core.h>


namespace rofrm {


class FileDialog : object
{
public:
	enum Mode {cOpen, cSave };
	typedef std::vector<string> FileList;
	Mode mode;
	bool multiSelect;
	string directory;
	string fileName;
	//string filePath;
	string title, filter;
	string defaultExt;
	FileList fileList;
	bool ok;
	FileDialog(const string title = "", Mode mode = cOpen);
	bool Execute();
	string GetFullName() {
		return directory+fileName;
	}
};

class DirectoryDialog: object
{
	string title;
	string initPath;
public:
	string directory;
	DirectoryDialog(const string title, const string initPath=""):title(title), initPath(initPath) {
	}
	bool Execute();
};

class ChooseColorDialog: object
{
public:
	Color color;
	ChooseColorDialog(Color cl=Color::cBlack):color(cl) {
	}
	bool Execute();
};


string ChooseSaveName(string directory, const char *title, const char *filter, const char *ext);

}

