#pragma once

#include <Core.h>


namespace rofrm {

class SysClipboard
{
	void *nextViewer;
public:
	enum{sigDraw = 0x0308};
	void SetViewer(Control *ctrl);
	void Forward();
	static bool PutToClipboard(Control *ctrl, char *pszText);
	static bool GetFromClipboard(Control *ctrl, string &str);
};



typedef void (*TOutputFun)(const string);

class SpawnConsole: public object
{
	class Impl;
	bool running;
	Impl &impl;
public:
	event<NotifyArgs> onTerminated;
	SpawnConsole();
	~SpawnConsole();
	bool IsRunning(){return running;}
	void Reset(TOutputFun outf, const string stpath="");
	int Run(const string cmdLine, bool wait=false);
	void Terminate();
	bool ReadData();
	bool WriteData(const string inp);
	void AddParams(const string name, const string param);
};


/*
class MetaFileDC : public GDC {
public:
  MetaFileDC(string fn, string tx);
  void Close();
  ~MetaFileDC() {
	  Close();
  }
};
*/


bool IsFileNewer(const string sFName, const string dFName);

bool CompSysName(const string s1, const string s2);

void FormSystemPath(string& s);

int GetClockCount();

bool GenerateConsoleBreak();

bool ExeShellCommand(const string& cmd,  const char *params=0,  const char *dir=0, bool trm=false);

}

