#pragma once

#include <Ctrls.h>
#include <vector>

namespace rofrm {

class TabCtrl;



class TabPage: public Panel
{
friend class TabCtrl;
	friend class TabMenCtrl;
public:
  TabPage();
  int TabIndex();
  int imageIndex;
};


enum TabAlignment {cTop, cBootom, cLeft, cRight};


class TabCtrl : public Control{
	friend class TabMenCtrl;
public:
class Impl;
	bool multiline;
	TabCtrl();
	property<int> selectedIndex;
	TabPage* SelectedTab()	{ return curCtrl; }
	void SelectTab(TabPage *tab);
	int TabCount() const 		{return tabs.size();}
	TabPage& GetTabPage(int ix) {
		assert(ix>-1 && ix<tabs.size());
		return *tabs[ix];
	}
	void Add(TabPage *tab) 	{InsertTab(tab, -1);}
	void InsertTab(TabPage *tab, int index);
	void RemoveAt(int index);
	event<NotifyArgs> onChange;
protected:
	TabPage *curCtrl;
	TabAlignment alignment;
	std::vector<TabPage*> tabs;
	void Layout();
};


template<class PG>
class TabView : public TabCtrl
{
public:
	PG* CurPage(){
		if(SelectedTab())
			return static_cast<PG*>(SelectedTab());
		else return 0;
	}
	PG* GetPage(int ix){
		return static_cast<PG*>(&GetTabPage(ix));
	}
	void DeletePage(int ix) {
		assert(ix<TabCount());
		PG *pg = static_cast<PG*>(&GetTabPage(ix));
		RemoveAt(ix);
		delete pg;
	}
	bool DeleteCurPage() {
		DeletePage(selectedIndex);
	}
	PG* NewPage(const string txt) {
		PG * pg = new PG;
		pg->text = txt;
		Add(pg);
	}
};



}

