#pragma once

#include <Core.h>
#include <vector>

namespace rofrm {

struct TbButton;
enum {bstEnable=1, bstCheck, bstPress, bstHide };

class ToolBar;

class ToolBarItems{
	friend class ToolBar;
	ToolBar *toolBar;
public:
	void Add(Action *act, int img=-1) {
		AddItem(act, 0, img);
	}
	void Add(int img, const string);
	void Add(Control *c) {
		AddItem(0, c, c->width+12);
	}
	int GetCount() {
		return data.size();
	}
	Action* GetButton(int i) {
		return data.at(i).action;
	}
	void SetState(int n, int state);
	void Clear();
	void Set(int n, Action *act, int img=-1);
protected:
	struct ItemInfo {
		int id;
		Action* action;
		Control *ctrl;
		TbButton *btn;
		int width;
	};
	typedef std::vector<ItemInfo> ItemList;
	ItemList data;
	std::vector<Action*> acts;
	ToolBarItems(ToolBar *toolBar): toolBar(toolBar){
	}
	~ToolBarItems() {
		Clear();
	}
	void AddItem(Action* act, Control *ctrl, int img);
};

//class Button;

class ToolBar : public Control {
friend class ToolBarItems;
public:
	class Impl;
	bool multiLine;
	bool showLabels;
	ToolBarItems items;
	event<NotifyArgs> onClick;
	ToolBar();  //=IDC_MAINTOOLBAR, int bwd=16, int bht=16
	void SetImages(int resId){
		imgResId=resId;
	}
	void Update();
private:
	int imgResId;
	void OnCommand(int cmd);
};

extern
	const int stdBtnWidth;

}

