#pragma once

#include <Core.h>
#include <vector>

namespace rofrm {

struct TbButton;
enum {bstEnable=1, bstCheck, bstPress, bstHide };


//class Button;

class ToolBar : public Control {
	struct ItemInfo {
		int id;
		Action* action;
		Control *ctrl;
		TbButton *btn;
		int width;
	};
public:
	class Impl;
	bool multiLine;
	bool showLabels;
	ToolBar();  //=IDC_MAINTOOLBAR, int bwd=16, int bht=16
	void SetImages(int resId){
		imgResId=resId;
	}
	void Add(Action *act, int img=-1) {
		AddItem(act, 0, img);
	}
	void AddSeparator(int width=8) {
		AddItem(0, 0, width);
	}
	void AddControl(Control *c) {
		AddItem(0, c, c->width+12);
	}
	void SetState(int n, int state);
	int GetItemCount() {
		return items.size();
	}
	Action* GetButton(int i) {
		return items.at(i).action;
	}
	void OnCommand(int cmd);
	event<NotifyArgs> onClick;
private:
	int imgResId;
	typedef std::vector<ItemInfo> ItemList;
	ItemList items;
	void AddItem(Action* act, Control *ctrl, int wd);
};

extern
	const int stdBtnWidth;

}

