#pragma once

#include <Core.h>
#include <vector>


namespace rofrm {


class TreeView : public Control{
public:
	TreeView();
	void SetImages(int resId) {
		imgResId = resId;
	}
	bool sorted;
	event<TreeArgs>  onExpand, onChoose;
	//---
	bool Expand(const TreeItem &item);
	bool IsExpanded(const TreeItem &item);
	void AppendItem(TreeItem &item, const string txt, const TreeItem *parent=0, int imgix=0);
	void SetItemData(const TreeItem &item, uint data);
	bool GetSelectedItem(TreeItem &item) const;
	string GetItemText(const TreeItem &item) const;
	uint GetItemData(const TreeItem &item) const;
	bool GetTopItem(TreeItem &item) {
		return GetTheItem(item, 0, 0);
	}
	bool GetParentItem(TreeItem &item, const TreeItem &child) const {
		return GetTheItem(item, &child, 1);
	}
	bool GetChildItem(TreeItem &item, const TreeItem &parent) const {
		return GetTheItem(item, &parent, 2);
	}
	bool GetNextItem(TreeItem &item) const;
	void DeleteItem(TreeItem &item);
	void DeleteAllItems();
protected:
	class Impl;
	int imgResId;
	//int maxImageIndex;
private:
	bool GetTheItem(TreeItem &item, const TreeItem *param, int id) const;
};

}

