
namespace CppDefs
{

static const  char *cFileFilter = "C/C++ (c cc cpp cxx h hh hxx hpp)|*.c;*.cc;*.cpp;*.cxx;*.h;*.hh;*.hpp;*.hxx";
static const  char *cSrcLexer = "cpp";

static const char *cKeyWords =
"and and_eq asm auto bitand bitor bool break case catch char class compl const const_cast "
"continue default delete do double dynamic_cast else enum explicit export extern false float for "
"friend goto if inline int long mutable namespace new not not_eq operator or or_eq private "
"protected public register reinterpret_cast return short signed sizeof static static_cast struct "
"switch template this throw true try typedef typeid typename union unsigned using virtual void "
"volatile wchar_t while xor xor_eq ";

static const char *cKeyWords1 = "uint int64 uchar string list set vector";



//styleId, Color BGR,  flags|size
static SciStyleDef  cStyles[] ={
{ 0,0x101010},   		//White space
{ 1,0x808080, 9},		//Comment
{ 2,0x808080, 9},		//Line Comment
{ 3,0x3F703F, 9},		//Doc comment: block comments: /** or /*!
{ 4,0x7F7F00},			//Number
{ 5,0xEF0000, SciStyleDef::sdBold},  //Keyword
{ 6,0x007F00},			//string
{ 7,0x009F00},			//char
{ 8,0x804080},			//IDL
{ 9,0x700F7F},			//Preprocessor
{10,0x000000, SciStyleDef::sdBold}, //Operators
{11,0x000000, }, 			//Indentifiers
{12,0x000000,SciStyleDef::sdFilled,0xE0C0E0},  //End of line where string is not closed
{15,0x3F703F, 8}, 		//Doc Comment Line:  /// or //!.
{16,0xAF0000, SciStyleDef::sdBold},			//Keywords2
{17,0xA06030, 9}, 		//Comment keyword
{18,0x204080, 9}, 		//Comment keyword error
{uint(-1)}
};


class SciEditDef: public SciLexerDef
{
	public:
	SciEditDef():SciLexerDef(cStyles, cKeyWords) {
		fileFilter = cFileFilter;
		lexer = cSrcLexer;
		autoCompleteStartCharacters = ".->:";
		statementIndent = "case default do else for if while";
		blockStart = "{";
		blockEnd = "}";
		keywords[1] = cKeyWords1;

	}
};

static SciEditDef sciEditDef;

} //namespace
