
namespace CssDefs
{

static const  char *cFileFilter = "CSS (css)|*.css";
static const  char *cSrcLexer = "css";


static const char *cKeyWords =
"color background-color background-image background-repeat background-attachment background-position background "
"font-family font-style font-variant font-weight font-size font "
"word-spacing letter-spacing text-decoration vertical-align text-transform text-align text-indent line-height "
"margin-top margin-right margin-bottom margin-left margin "
"padding-top padding-right padding-bottom padding-left padding "
"border-top-width border-right-width border-bottom-width border-left-width border-width "
"border-top border-right border-bottom border-left border "
"border-color border-style width height float clear "
"display white-space list-style-type list-style-image list-style-position list-style";


static const char *cKeyWords1 =
"first-letter first-line link active visited "
"first-child focus hover lang before after left right first";

static const char *cKeyWords2 =
"border-top-color border-right-color border-bottom-color border-left-color border-color "
"border-top-style border-right-style border-bottom-style border-left-style border-style "
"top right bottom left position z-index direction unicode-bidi "
"min-width max-width min-height max-height overflow clip visibility content quotes "
"counter-reset counter-increment marker-offset "
"size marks page-break-before page-break-after page-break-inside page orphans widows "
"font-stretch font-size-adjust unicode-range units-per-em src "
"panose-1 stemv stemh slope cap-height x-height ascent descent widths bbox definition-src "
"baseline centerline mathline topline text-shadow "
"caption-side table-layout border-collapse border-spacing empty-cells speak-header "
"cursor outline outline-width outline-style outline-color "
"volume speak pause-before pause-after pause cue-before cue-after cue "
"play-during azimuth elevation speech-rate voice-family pitch pitch-range stress richness "
"speak-punctuation speak-numeral";


//styleId, Color BGR,  flags|size
static SciStyleDef  cStyles[] ={
{ 0,0xFF00},
{ 1,0x007F00, 9},
{ 2,0x007F00, 9},
{ 3,0x3F703F, 9},
{ 4,0x7F7F00},
{ 5,0xEF0000, SciStyleDef::sdBold},
{ 6,0x7F007F},
{ 7,0x7F007F},
{ 8,0x804080},
{ 9,0x700F7F},
{10,0x000000, SciStyleDef::sdBold},
{11,0x007F00, 9},
{12,0x007F00, 9},
{13,0x007F00, 9},
{14,0x007F00, 9},
{15,0x3F703F, 8}, //font:Comic Sans MS,size:9},  coment line
{16,0x4000B0},
{17,0xA06030, 9}, //font:Comic Sans MS,size:9}, //17
{18,0x204080, 9}, //font:Comic Sans MS,size:9},
{104,0x007F00,9},
{118,0x000033,9},
{119,0x007F00,9},
{120,0x009F00,9},
{121,0x7F007F,SciStyleDef::sdBold}, //Keyword
{122,0xCC9900,9},
{123,0x00007F,9},
{124,0x999999,9},
{125,0x666666,9},
{126,0x007F00,9},
{127,0x000000,9},
{uint(-1)}
};




class SciEditDef: public SciLexerDef
{
public:
  SciEditDef():SciLexerDef(cStyles, cKeyWords)
  {
		fileFilter = cFileFilter;
		lexer = cSrcLexer;
		autoCompleteStartCharacters = ".";
		statementIndent = "case default do else for if while";
		blockStart = "5 {";
		blockEnd = "5 }";
		keywords[1] = cKeyWords1;
		keywords[2] = cKeyWords2;
  }
};

static SciEditDef sciEditDef;

} //namespace
