
namespace FortranDefs
{

static const  char *cFileFilter = "Fortran (f for f90 f95 f2k)|*.f;*.for;*.f90;*.f95;*.f2k";
//static const  char *cSrcLexer = "fortran";
static const  char *cSrcLexer = "f77";


static const char *cKeyWords =
"access action advance allocatable allocate "
"apostrophe assign assignment associate asynchronous backspace "
"bind blank blockdata call case character class close common "
"complex contains continue cycle data deallocate decimal delim "
"default dimension direct do dowhile double doubleprecision else "
"elseif elsewhere encoding end endassociate endblockdata enddo "
"endfile endforall endfunction endif endinterface endmodule endprogram "
"endselect endsubroutine endtype endwhere entry eor equivalence "
"err errmsg exist exit external file flush fmt forall form format "
"formatted function go goto id if implicit in include inout "
"integer inquire intent interface intrinsic iomsg iolength "
"iostat kind len logical module name named namelist nextrec nml "
"none nullify number only open opened operator optional out pad "
"parameter pass pause pending pointer pos position precision "
"print private program protected public quote read readwrite "
"real rec recl recursive result return rewind save select "
"selectcase selecttype sequential sign size stat status stop stream "
"subroutine target then to type unformatted unit use value "
"volatile wait where while write ";




//styleId, Color BGR,  flags|size
static SciStyleDef  cStyles[] ={
{ 0,0x101010},  //Default
{ 1,0x808080},  //Comment
{ 2,0x7F007F},  //Number
{ 3,0x007F00},  //Single quoted string
{ 4,0x7F7F00},  //Double quoted string
{ 5,0xEF0000, SciStyleDef::sdFilled,0xE0C0E0},  //End of line where string is not closed
{ 6,0x7F007F},  //Operators
{ 7,0x000F1F},  //Identifiers
{ 8,0x7F0000,SciStyleDef::sdBold},  //Keywords
{ 9,0x700F7F,SciStyleDef::sdBold},  //Keywords2
{10,0xFF0000, SciStyleDef::sdBold},  //Keywords3
{11,0xFF00FF}, //Preprocessor
{12,0x3F703F},
{13,0x4000B0},  //Labels
{14,0xA06030},  //Continuation
{uint(-1)}
};


class SciEditDef: public SciLexerDef
{
	public:
	SciEditDef():SciLexerDef(cStyles, cKeyWords) {
		fileFilter = cFileFilter;
		lexer = cSrcLexer;
		//blockStart = "{";
		//blockEnd = "}";
	}
};

static SciEditDef sciEditDef;

} //namespace
