
namespace HtmlDefs
{
static const  char *cFileFilter = "Web (html htm shtml)|*.html;*.htm;*.asp;*.shtml;*.htd"
											  "|PHP (php php3 phtml)|*.php3;*.phtml;*.php";

static const  char *cSrcLexer = "hypertext";

static const char *cKeyWords =
"a abbr acronym address applet area b base basefont "
"bdo big blockquote body br button caption center "
"cite code col colgroup dd del dfn dir div dl dt em "
"fieldset font form frame frameset h1 h2 h3 h4 h5 h6 "
"head hr html i iframe img input ins isindex kbd label "
"legend li link map menu meta noframes noscript "
"object ol optgroup option p param pre q s samp "
"script select small span strike strong style sub sup "
"table tbody td textarea tfoot th thead title tr tt u ul "
"var xml xmlns"
"abbr accept-charset accept accesskey action align alink "
"alt archive axis background bgcolor border "
"cellpadding cellspacing char charoff charset checked cite "
"class classid clear codebase codetype color cols colspan "
"compact content coords "
"data datafld dataformatas datapagesize datasrc datetime "
"declare defer dir disabled enctype event "
"face for frame frameborder "
"headers height href hreflang hspace http-equiv "
"id ismap label lang language leftmargin link longdesc "
"marginwidth marginheight maxlength media method multiple "
"name nohref noresize noshade nowrap "
"object onblur onchange onclick ondblclick onfocus "
"onkeydown onkeypress onkeyup onload onmousedown "
"onmousemove onmouseover onmouseout onmouseup "
"onreset onselect onsubmit onunload "
"profile prompt readonly rel rev rows rowspan rules "
"scheme scope selected shape size span src standby start style "
"summary tabindex target text title topmargin type usemap "
"valign value valuetype version vlink vspace width "
"text password checkbox radio submit reset "
"file hidden image";

static const char *cKeyWords4 =
"and array as bool boolean break case cfunction class const continue declare "
"default die directory do double echo else elseif empty enddeclare endfor "
"endforeach endif endswitch endwhile eval exit extends false float for "
"foreach function global if include include_once int integer isset list new "
"null object old_function or parent print real require require_once resource "
"return static stdclass string switch true unset use var while xor "
"abstract catch clone exception final implements interface php_user_filter "
"private protected public this throw try "
"__class__ __file__ __function__ __line__ __method__ __sleep __wakeup";


//styleId, Color BGR,  flags|size
static SciStyleDef  cStyles[] ={
{ 0,0x000},  						// Text
{ 1,0x7F0000, SciStyleDef::sdBold},      // Tags
{ 2,0xAF0000, 9},				// Unknown Tags
{ 3,0x3F00AF},					// Attributes
{ 4,0x5F00AF},					// Unknown Attributes
{ 5,0xEF00AF},  					//Numbers
{ 6,0x007F00},					//Double quoted strings
{ 7,0x7F007F},
{ 8,0x804080},
{ 9,0x700F7F},
{10,0x000000},
{11,0x007F00, 9},
{12,0x007F00, 9},
{13,0x007F00, 9},
{14,0x007F00, 9},
{15,0x3F703F, 8}, //font:Comic Sans MS,size:9},  coment line
{16,0x4000B0},
{17,0xA06030, 9}, //font:Comic Sans MS,size:9}, //17
{18,0x204080, 9}, //font:Comic Sans MS,size:9},
{40,0x7F7F00},  //js
{41,0x000000, SciStyleDef::sdBold},
{42,0x808080},
{43,0x808080},
{44,0x808080},
{45,0x808080},
{46,0x000000,},
{47,0x808080},
{48,0x808080},
{49,0x808080},
{50,0x808080},
{51,0x808080},
{52,0x808080},
{55,0x7F7F00},
{56,0x000000},
{57,0x007F00},
{58,0x007F00},
{59,0x7F7F7F},
{60,0x007F7F},
{61,0x000000},
{62,0x00007F},
{63,0x7F007F},
{64,0x7F007F},
{65,0x000000},
{66,0,SciStyleDef::sdFilled, 0xBFBBB0},
{67,0,0, 0xFFBBB0},
{104,0x007F00,0, 0xFFF8F8},
{118,0x000033,SciStyleDef::sdFilled, 0xFFF8F8},  //PHP Default
{119,0x007F00,0, 0xFFF8F8},
{120,0x009F00,0, 0xFFF8F8},
{121,0x7F007F,SciStyleDef::sdBold, 0xFFF8F8}, //PHP Keyword
{122,0xCC9900,0, 0xFFF8F8},
{123,0x00007F,0, 0xFFF8F8},
{124,0x999999,8|SciStyleDef::sdItalic, 0xFFF8F8},  //Comment
{125,0x666666,0, 0xFFF8F8},
{126,0x007F00,0, 0xFFF8F8},
{127,0x000000,0, 0xFFF8F8},
{uint(-1)}
};





class SciEditDef: public SciLexerDef
{
public:
  SciEditDef():SciLexerDef(cStyles, cKeyWords)
  {
	fileFilter = cFileFilter;
    lexer = cSrcLexer;
    autoCompleteStartCharacters = "=<.";
	//statementIndent = "";
	blockStart = "<";
	blockEnd = "</";
	keywords[4] = cKeyWords4;
  }
};

static SciEditDef sciEditDef;

} //namespace
