
namespace JavaScriptDefs
{

static const  char *cFileFilter = "JavaScript (js)|*.js";
static const  char *cSrcLexer = "cpp";

static const char *cKeyWords =
"abstract boolean break byte case catch char class "
"const continue debugger default delete do double else enum export extends "
"final finally float for function goto if implements import in instanceof "
"int interface long native new package private protected public "
"return short static super switch synchronized this throw throws "
"transient try typeof var void volatile while with";




//styleId, Color BGR,  flags|size
static SciStyleDef  cStyles[] ={
{ 0,0x808080},
{ 1,0x007F00, 9},
{ 2,0x007F00, 9},
{ 3,0x3F703F, 9},
{ 4,0x7F7F00},
{ 5,0xEF0000, SciStyleDef::sdBold},
{ 6,0x7F007F},
{ 7,0x7F007F},
{ 8,0x804080},
{ 9,0x700F7F},
{10,0x000000, SciStyleDef::sdBold},
//{12,0x000000,font:Courier New,size:10,back:#E0C0E0,eolfilled},
//{13,0x007F00,font:Courier New,size:10,back:#E0FFE0,eolfilled},
//{14,0x3F7F3F,font:Courier New,size:10,back:#E0F0FF,eolfilled},
{15,0x3F703F, 8}, //font:Comic Sans MS,size:9},  coment line
{16,0x4000B0},
{17,0xA06030, 9}, //font:Comic Sans MS,size:9}, //17
{18,0x204080, 9}, //font:Comic Sans MS,size:9},
{uint(-1)}
};


class SciEditDef: public SciLexerDef
{
	public:
	SciEditDef():SciLexerDef(cStyles, cKeyWords) {
		fileFilter = cFileFilter;
		lexer = cSrcLexer;
		autoCompleteStartCharacters = ".->:";
		statementIndent = "case default do else for if while";
		blockStart = "{";
		blockEnd = "}";
	}
};

static SciEditDef sciEditDef;

} //namespace

namespace JavaDefs
{

static const  char *cFileFilter = "Java (java)|*.java";
static const  char *cSrcLexer = "cpp";

static const char *cKeyWords =
"abstract assert boolean break byte case catch char class "
"const continue default do double else extends final finally float for future "
"generic goto if implements import inner instanceof int interface long "
"native new null outer package private protected public rest "
"return short static super switch synchronized this throw throws "
"transient try var void volatile while";



class SciEditDef: public SciLexerDef
{
	public:
	SciEditDef():SciLexerDef(JavaScriptDefs::cStyles, cKeyWords) {
		fileFilter = cFileFilter;
		lexer = cSrcLexer;
		autoCompleteStartCharacters = ".->:";
		statementIndent = "case default do else for if while";
		blockStart = "{";
		blockEnd = "}";
	}
};

static SciEditDef sciEditDef;

} //namespace
