
namespace PasDefs {

static const  char *cFileFilter = "Pascal (dpr dpk pas dfm inc)|*.dpr;*.dpk;*.pas;*.dfm;*.inc;*.pp";
static const  char *cSrcLexer = "pascal";

static const char *cKeyWords =
"and array asm begin case cdecl class const constructor contains "
"default destructor div do downto else end end. except exit exports external "
"far file finalization finally for function goto if implementation in index inherited "
"initialization inline interface label library message mod near nil not "
"object of on or out overload override package packed pascal private procedure program "
"property protected public published raise read record register repeat requires resourcestring "
"safecall set shl shr stdcall stored string then threadvar to try type unit "
"until uses var virtual while with write xor";

//keywordclass.pascalclasses=write read default public protected private property published stored


//styleId, Color BGR,  flags|size
static SciStyleDef  cStyles[] ={
{ 0,0x808080},
{ 1,0x007F00, 9},
{ 2,0x007F00, 9},
{ 3,0x3F703F, 9},
{ 4,0x7F7F00},
{ 5,0xEF0000, SciStyleDef::sdBold},
{ 6,0x7F007F},
{ 7,0x7F007F},
{ 8,0x804080},
{ 9,0x700F7F},
{10,0x000000, SciStyleDef::sdBold},
//{12,0x000000,font:Courier New,size:10,back:#E0C0E0,eolfilled},
//{13,0x007F00,font:Courier New,size:10,back:#E0FFE0,eolfilled},
//{14,0x3F7F3F,font:Courier New,size:10,back:#E0F0FF,eolfilled},
{15,0x3F703F, 8}, //font:Comic Sans MS,size:9},  coment line
{16,0x4000B0},
{17,0xA06030, 9}, //font:Comic Sans MS,size:9}, //17
{18,0x204080, 9}, //font:Comic Sans MS,size:9},
{uint(-1)}
};


class SciEditDef: public SciLexerDef
{
public:
	SciEditDef():SciLexerDef(cStyles, cKeyWords)
	{
		fileFilter = cFileFilter;
		lexer = cSrcLexer;
		callTipIgnoreCase = true;
		autoCompleteStartCharacters = ".";
		statementIndent = "case catch class default do else for then private protected public struct try union while type";
		blockStart = "begin";
		blockEnd = "end";
	}
};

static SciEditDef sciEditDef;

} //namespace
