
namespace PropsDefs
{
static const  char *cFileFilter = "Properties (ini inf reg url cfg cnf)|*.ini;*.inf;*.reg;*.url;*.cfg;*.cnf;*.aut";
static const  char *cSrcLexer = "props";

static const char *cKeyWords = "";

//styleId, Color BGR,  flags|size
static SciStyleDef  cStyles[] ={
{ 0,0x000},    				//Default
{ 1,0x808080},			//Comment
{ 2,0x007F00,SciStyleDef::sdFilled, 0xE0F0F0},			//Section
{ 3,0x3F703F},
{ 4,0x7F7F00},
{ 5,0xEF0000},
{34,0xA06030},
{35,0x204080},
{uint(-1)}
};


class SciEditDef: public SciLexerDef
{
public:
	SciEditDef():SciLexerDef(cStyles, cKeyWords)
	{
		fileFilter = cFileFilter;
		lexer = cSrcLexer;
		callTipIgnoreCase = true;
	}
};

static SciEditDef sciEditDef;
} //namespace

//===============================================================

namespace BatchDefs
{
static const  char *cFileFilter = "Batch (bat cmd nt)|*.bat;*.cmd;*.nt";
static const  char *cSrcLexer = "batch";

static const char *cKeyWords =
"rem set if exist errorlevel for in do "
"break call chcp cd chdir choice cls country ctty date del erase dir echo "
"exit goto loadfix loadhigh mkdir md move path pause prompt rename ren "
"rmdir rd shift time type ver verify vol "
"com con lpt nul "
"color copy defined else not start";

//styleId, Color BGR,  flags|size
static SciStyleDef  cStyles[] ={
{ 0,0x000},   				//Default
{ 1,0x808080},			//Comment
{ 2,0x7F0000, SciStyleDef::sdBold},		//Keywords
{ 3,0xFFFF00,SciStyleDef::sdFilled, 0x606060},		//Label
{ 4,0x7F7F00},
{ 5,0xEF0000, },
{ 6,0x7F007F},
{ 7,0x7F007F},
{uint(-1)}
};


class SciEditDef: public SciLexerDef
{
public:
	SciEditDef():SciLexerDef(cStyles, cKeyWords)
	{
		fileFilter = cFileFilter;
		lexer = cSrcLexer;
		callTipIgnoreCase = true;
	}
};

static SciEditDef sciEditDef;
} //namespace


